#include "GSMclick_objects.h"
#include "GSMclick_resources.h"

//--------------------- User code ---------------------//

extern void send_atc(char *s);
extern void wait_response(char rspns);
extern char atc2[];
extern char atcATA[];
extern char atcATH[];
extern char atcATD[];
extern char number[];
extern char btnCap_Answer[];
extern char btnCap_Reject[];
extern char btnCap_Call[];
extern char btnCap_End[];
extern char msgDial[];
extern char msgLastNUM[];
       char msgCalling[] = "Calling...";
       char msgCaller[]  = "Caller num.:";
       char msgCallEnd[] = "Call ended";
       char msgGSM[]     = "GSM click";
extern const GSM_OK;
       char call_at[18];
extern char callerid;
extern char incall;
       char _plus[2] = "+";
       char _char[2] = " ";
extern char phoneScreen;
extern char receiveCall;

void ClearLabel(TLabel *lbl){
  Glcd_Set_Font_Adv(lbl->Fontname, 0, 0);
  Glcd_Write_Text_Adv(lbl->Caption, lbl->Left, lbl->Top);
}

void UpdateLable(TLabel *lbl, char *caption){
    ClearLabel(lbl);
    lbl->Caption = caption;
    DrawLabel(lbl);
}

void CallATC(){
    call_at[0] = 0;
    strcat(call_at, atcATD);
    strcat(call_at, number);
    strcat(call_at, ";");
    send_atc(call_at);
}

void DisableButton(TButton *btn){
  btn->Active = 0;
  btn->FontName = &Tahoma12x16_Regular;
}
void EnableButton(TButton *btn){
  btn->Active = 1;
  btn->FontName = &Tahoma14x16_Bold;
}

void ResetNumber(){
  ClearLabel(&lblNumber);
  lblNumber_Caption[0] = ' ';
  lblNumber_Caption[1] = 0;
  number[0] = 0;
  DrawLabel(&lblNumber);
}

void addNumber(char caption[]){
  if (lblNumber_Caption[0] != ' '){
    ResetNumber();
  }
  if(strlen(lblNumber.Caption) < 19){
    switch(strlen(lblNumber.Caption)){
      case 5:
        strcat(lblNumber.Caption, _char);
        break;
      case 8:
        strcat(lblNumber.Caption, _char);
        break;
      case 11:
        strcat(lblNumber.Caption, _char);
        break;
      case 14:
        strcat(lblNumber.Caption, _char);
        break;
    }
    strcat(lblNumber.Caption, caption);
    strcat(number, caption);
    DrawLabel(&lblNumber);
  }
}
//----------------- End of User code ------------------//

// Event Handlers

void Button1OnClick() {
  addNumber(Button1_Caption);
}

void Button2OnClick() {
  addNumber(Button2_Caption);
}

void Button3OnClick() {
  addNumber(Button3_Caption);
}

void Button4OnClick() {
  addNumber(Button4_Caption);
}

void Button5OnClick() {
  addNumber(Button5_Caption);
}

void Button6OnClick() {
  addNumber(Button6_Caption);
}

void Button7OnClick() {
  addNumber(Button7_Caption);
}

void Button8OnClick() {
  addNumber(Button8_Caption);
}

void Button9OnClick() {
  addNumber(Button9_Caption);
}

void Button10OnClick() {
  addNumber(Button10_Caption);
}

void ButtonPlusOnClick() {
  addNumber(_plus);
}

void btnPhoneOnClick() {
  if(strlen(number) < 1){
    lblStatus.Caption = msgGSM;
    lblInfo.Caption = msgDial;
    DisableButton(&btnCall);
  }
  else{
    lblStatus.Caption = msgLastNUM;
    lblInfo.Caption = lblNumber.Caption;
    EnableButton(&btnCall);
    callerid = 0;
  }
  DrawScreen(&Phone);
  PhoneScreen = 1;
}

void btnDialerOnClick() {
  strcpy(lblNumber.Caption, lblInfo.Caption);
  DrawScreen(&Dialer);
  PhoneScreen = 0;
}

void btnDelOnClick() {
  if (strlen(lblNumber.Caption) > 1){
    ClearLabel(&lblNumber);
    number[strlen(number)-1] = 0;
    lblNumber_Caption[strlen(lblNumber.Caption)-1] = 0;
    if( lblNumber_Caption[strlen(lblNumber.Caption)-1] == 32 )
      lblNumber_Caption[strlen(lblNumber.Caption)-1] = 0;
    DrawLabel(&lblNumber);
  }
  if (strlen(lblNumber.Caption) == 0){
    strcat(lblNumber.Caption, _char);
  }
}

void btnXOnClick() {
   ClearLabel(&lblNumber);
   strcpy(lblNumber.Caption, _char);
   number[0] = 0;
}

void btnCallOnClick() {
  if(receiveCall){
    send_atc(atcATA);
    wait_response(GSM_OK);
    btnEnd.Caption = btnCap_End;
    DrawButton(&btnEnd);
    incall = 1;
    receiveCall = 2;
  }
  else if(!incall){
    btnDialer.Active = 0;
    UpdateLable(&lblStatus, &msgCalling);
    if (!callerid){
      UpdateLable(&lblInfo, lblNumber.Caption);
    }
    // Call diled number
    CallATC();
    wait_response(GSM_OK);
    EnableButton(&btnEnd);
    DrawButton(&btnEnd);
    incall = 1;
  }
  DisableButton(&btnCall);
  DrawButton(&btnCall);
}

void btnEndOnClick() {
  btnDialer.Active = 1;
  if(receiveCall > 0){
    UpdateLable(&lblStatus, &msgCaller);
    receiveCall = 0;
  }
  else{
    UpdateLable(&lblStatus, &msgCallEnd);
    Delay_ms(1250);
    UpdateLable(&lblStatus, &msgLastNUM);
  }
  send_atc(atcATH);
  wait_response(GSM_OK);

  btnCall.Caption = btnCap_Call;
  btnEnd.Caption =  btnCap_End;
  EnableButton(&btnCall);
  DisableButton(&btnEnd);
  DrawButton(&btnCall);
  DrawButton(&btnEnd);
  incall = 0;
}